* [PATCH net-next v4 1/5] netconsole: add target_state enum
2025-11-16 17:14 [PATCH net-next v4 0/5] netconsole: support automatic target recovery Andre Carvalho
@ 2025-11-16 17:14 ` Andre Carvalho
2025-11-16 17:14 ` [PATCH net-next v4 2/5] netconsole: convert 'enabled' flag to enum for clearer state management Andre Carvalho
` (3 subsequent siblings)
4 siblings, 0 replies; 10+ messages in thread
From: Andre Carvalho @ 2025-11-16 17:14 UTC (permalink / raw)
To: Breno Leitao, Andrew Lunn, David S. Miller, Eric Dumazet,
Jakub Kicinski, Paolo Abeni, Shuah Khan, Simon Horman
Cc: netdev, linux-kernel, linux-kselftest, Andre Carvalho
From: Breno Leitao <leitao@debian.org>
Introduces a enum to track netconsole target state which is going to
replace the enabled boolean.
Signed-off-by: Breno Leitao <leitao@debian.org>
Signed-off-by: Andre Carvalho <asantostc@gmail.com>
---
drivers/net/netconsole.c | 5 +++++
1 file changed, 5 insertions(+)
diff --git a/drivers/net/netconsole.c b/drivers/net/netconsole.c
index bb6e03a92956..7a7eba041e23 100644
--- a/drivers/net/netconsole.c
+++ b/drivers/net/netconsole.c
@@ -117,6 +117,11 @@ enum sysdata_feature {
SYSDATA_MSGID = BIT(3),
};
+enum target_state {
+ STATE_DISABLED,
+ STATE_ENABLED,
+};
+
/**
* struct netconsole_target - Represents a configured netconsole target.
* @list: Links this target into the target_list.
--
2.51.2
^ permalink raw reply related [flat|nested] 10+ messages in thread* [PATCH net-next v4 2/5] netconsole: convert 'enabled' flag to enum for clearer state management
2025-11-16 17:14 [PATCH net-next v4 0/5] netconsole: support automatic target recovery Andre Carvalho
2025-11-16 17:14 ` [PATCH net-next v4 1/5] netconsole: add target_state enum Andre Carvalho
@ 2025-11-16 17:14 ` Andre Carvalho
2025-11-16 17:14 ` [PATCH net-next v4 3/5] netconsole: add STATE_DEACTIVATED to track targets disabled by low level Andre Carvalho
` (2 subsequent siblings)
4 siblings, 0 replies; 10+ messages in thread
From: Andre Carvalho @ 2025-11-16 17:14 UTC (permalink / raw)
To: Breno Leitao, Andrew Lunn, David S. Miller, Eric Dumazet,
Jakub Kicinski, Paolo Abeni, Shuah Khan, Simon Horman
Cc: netdev, linux-kernel, linux-kselftest, Andre Carvalho
This patch refactors the netconsole driver's target enabled state from a
simple boolean to an explicit enum (`target_state`).
This allow the states to be expanded to a new state in the upcoming
change.
Co-developed-by: Breno Leitao <leitao@debian.org>
Signed-off-by: Breno Leitao <leitao@debian.org>
Signed-off-by: Andre Carvalho <asantostc@gmail.com>
---
drivers/net/netconsole.c | 52 ++++++++++++++++++++++++++----------------------
1 file changed, 28 insertions(+), 24 deletions(-)
diff --git a/drivers/net/netconsole.c b/drivers/net/netconsole.c
index 7a7eba041e23..2d15f7ab7235 100644
--- a/drivers/net/netconsole.c
+++ b/drivers/net/netconsole.c
@@ -132,12 +132,12 @@ enum target_state {
* @sysdata_fields: Sysdata features enabled.
* @msgcounter: Message sent counter.
* @stats: Packet send stats for the target. Used for debugging.
- * @enabled: On / off knob to enable / disable target.
+ * @state: State of the target.
* Visible from userspace (read-write).
* We maintain a strict 1:1 correspondence between this and
* whether the corresponding netpoll is active or inactive.
* Also, other parameters of a target may be modified at
- * runtime only when it is disabled (enabled == 0).
+ * runtime only when it is disabled (state == STATE_DISABLED).
* @extended: Denotes whether console is extended or not.
* @release: Denotes whether kernel release version should be prepended
* to the message. Depends on extended console.
@@ -165,7 +165,7 @@ struct netconsole_target {
u32 msgcounter;
#endif
struct netconsole_target_stats stats;
- bool enabled;
+ enum target_state state;
bool extended;
bool release;
struct netpoll np;
@@ -257,6 +257,7 @@ static struct netconsole_target *alloc_and_init(void)
nt->np.local_port = 6665;
nt->np.remote_port = 6666;
eth_broadcast_addr(nt->np.remote_mac);
+ nt->state = STATE_DISABLED;
return nt;
}
@@ -275,7 +276,7 @@ static void netconsole_process_cleanups_core(void)
mutex_lock(&target_cleanup_list_lock);
list_for_each_entry_safe(nt, tmp, &target_cleanup_list, list) {
/* all entries in the cleanup_list needs to be disabled */
- WARN_ON_ONCE(nt->enabled);
+ WARN_ON_ONCE(nt->state == STATE_ENABLED);
do_netpoll_cleanup(&nt->np);
/* moved the cleaned target to target_list. Need to hold both
* locks
@@ -398,7 +399,7 @@ static void trim_newline(char *s, size_t maxlen)
static ssize_t enabled_show(struct config_item *item, char *buf)
{
- return sysfs_emit(buf, "%d\n", to_target(item)->enabled);
+ return sysfs_emit(buf, "%d\n", to_target(item)->state == STATE_ENABLED);
}
static ssize_t extended_show(struct config_item *item, char *buf)
@@ -565,8 +566,8 @@ static ssize_t enabled_store(struct config_item *item,
const char *buf, size_t count)
{
struct netconsole_target *nt = to_target(item);
+ bool enabled, current_enabled;
unsigned long flags;
- bool enabled;
ssize_t ret;
mutex_lock(&dynamic_netconsole_mutex);
@@ -575,9 +576,10 @@ static ssize_t enabled_store(struct config_item *item,
goto out_unlock;
ret = -EINVAL;
- if (enabled == nt->enabled) {
+ current_enabled = nt->state == STATE_ENABLED;
+ if (enabled == current_enabled) {
pr_info("network logging has already %s\n",
- nt->enabled ? "started" : "stopped");
+ current_enabled ? "started" : "stopped");
goto out_unlock;
}
@@ -610,16 +612,16 @@ static ssize_t enabled_store(struct config_item *item,
if (ret)
goto out_unlock;
- nt->enabled = true;
+ nt->state = STATE_ENABLED;
pr_info("network logging started\n");
} else { /* false */
/* We need to disable the netconsole before cleaning it up
* otherwise we might end up in write_msg() with
- * nt->np.dev == NULL and nt->enabled == true
+ * nt->np.dev == NULL and nt->state == STATE_ENABLED
*/
mutex_lock(&target_cleanup_list_lock);
spin_lock_irqsave(&target_list_lock, flags);
- nt->enabled = false;
+ nt->state = STATE_DISABLED;
/* Remove the target from the list, while holding
* target_list_lock
*/
@@ -648,7 +650,7 @@ static ssize_t release_store(struct config_item *item, const char *buf,
ssize_t ret;
mutex_lock(&dynamic_netconsole_mutex);
- if (nt->enabled) {
+ if (nt->state == STATE_ENABLED) {
pr_err("target (%s) is enabled, disable to update parameters\n",
config_item_name(&nt->group.cg_item));
ret = -EINVAL;
@@ -675,7 +677,7 @@ static ssize_t extended_store(struct config_item *item, const char *buf,
ssize_t ret;
mutex_lock(&dynamic_netconsole_mutex);
- if (nt->enabled) {
+ if (nt->state == STATE_ENABLED) {
pr_err("target (%s) is enabled, disable to update parameters\n",
config_item_name(&nt->group.cg_item));
ret = -EINVAL;
@@ -699,7 +701,7 @@ static ssize_t dev_name_store(struct config_item *item, const char *buf,
struct netconsole_target *nt = to_target(item);
mutex_lock(&dynamic_netconsole_mutex);
- if (nt->enabled) {
+ if (nt->state == STATE_ENABLED) {
pr_err("target (%s) is enabled, disable to update parameters\n",
config_item_name(&nt->group.cg_item));
mutex_unlock(&dynamic_netconsole_mutex);
@@ -720,7 +722,7 @@ static ssize_t local_port_store(struct config_item *item, const char *buf,
ssize_t ret = -EINVAL;
mutex_lock(&dynamic_netconsole_mutex);
- if (nt->enabled) {
+ if (nt->state == STATE_ENABLED) {
pr_err("target (%s) is enabled, disable to update parameters\n",
config_item_name(&nt->group.cg_item));
goto out_unlock;
@@ -742,7 +744,7 @@ static ssize_t remote_port_store(struct config_item *item,
ssize_t ret = -EINVAL;
mutex_lock(&dynamic_netconsole_mutex);
- if (nt->enabled) {
+ if (nt->state == STATE_ENABLED) {
pr_err("target (%s) is enabled, disable to update parameters\n",
config_item_name(&nt->group.cg_item));
goto out_unlock;
@@ -765,7 +767,7 @@ static ssize_t local_ip_store(struct config_item *item, const char *buf,
int ipv6;
mutex_lock(&dynamic_netconsole_mutex);
- if (nt->enabled) {
+ if (nt->state == STATE_ENABLED) {
pr_err("target (%s) is enabled, disable to update parameters\n",
config_item_name(&nt->group.cg_item));
goto out_unlock;
@@ -790,7 +792,7 @@ static ssize_t remote_ip_store(struct config_item *item, const char *buf,
int ipv6;
mutex_lock(&dynamic_netconsole_mutex);
- if (nt->enabled) {
+ if (nt->state == STATE_ENABLED) {
pr_err("target (%s) is enabled, disable to update parameters\n",
config_item_name(&nt->group.cg_item));
goto out_unlock;
@@ -839,7 +841,7 @@ static ssize_t remote_mac_store(struct config_item *item, const char *buf,
ssize_t ret = -EINVAL;
mutex_lock(&dynamic_netconsole_mutex);
- if (nt->enabled) {
+ if (nt->state == STATE_ENABLED) {
pr_err("target (%s) is enabled, disable to update parameters\n",
config_item_name(&nt->group.cg_item));
goto out_unlock;
@@ -1330,7 +1332,7 @@ static void drop_netconsole_target(struct config_group *group,
* The target may have never been enabled, or was manually disabled
* before being removed so netpoll may have already been cleaned up.
*/
- if (nt->enabled)
+ if (nt->state == STATE_ENABLED)
netpoll_cleanup(&nt->np);
config_item_put(&nt->group.cg_item);
@@ -1459,7 +1461,7 @@ static int netconsole_netdev_event(struct notifier_block *this,
case NETDEV_RELEASE:
case NETDEV_JOIN:
case NETDEV_UNREGISTER:
- nt->enabled = false;
+ nt->state = STATE_DISABLED;
list_move(&nt->list, &target_cleanup_list);
stopped = true;
}
@@ -1726,7 +1728,8 @@ static void write_ext_msg(struct console *con, const char *msg,
spin_lock_irqsave(&target_list_lock, flags);
list_for_each_entry(nt, &target_list, list)
- if (nt->extended && nt->enabled && netif_running(nt->np.dev))
+ if (nt->extended && nt->state == STATE_ENABLED &&
+ netif_running(nt->np.dev))
send_ext_msg_udp(nt, msg, len);
spin_unlock_irqrestore(&target_list_lock, flags);
}
@@ -1746,7 +1749,8 @@ static void write_msg(struct console *con, const char *msg, unsigned int len)
spin_lock_irqsave(&target_list_lock, flags);
list_for_each_entry(nt, &target_list, list) {
- if (!nt->extended && nt->enabled && netif_running(nt->np.dev)) {
+ if (!nt->extended && nt->state == STATE_ENABLED &&
+ netif_running(nt->np.dev)) {
/*
* We nest this inside the for-each-target loop above
* so that we're able to get as much logging out to
@@ -1902,7 +1906,7 @@ static struct netconsole_target *alloc_param_target(char *target_config,
*/
goto fail;
} else {
- nt->enabled = true;
+ nt->state = STATE_ENABLED;
}
populate_configfs_item(nt, cmdline_count);
--
2.51.2
^ permalink raw reply related [flat|nested] 10+ messages in thread* [PATCH net-next v4 3/5] netconsole: add STATE_DEACTIVATED to track targets disabled by low level
2025-11-16 17:14 [PATCH net-next v4 0/5] netconsole: support automatic target recovery Andre Carvalho
2025-11-16 17:14 ` [PATCH net-next v4 1/5] netconsole: add target_state enum Andre Carvalho
2025-11-16 17:14 ` [PATCH net-next v4 2/5] netconsole: convert 'enabled' flag to enum for clearer state management Andre Carvalho
@ 2025-11-16 17:14 ` Andre Carvalho
2025-11-16 17:14 ` [PATCH net-next v4 4/5] netconsole: resume previously deactivated target Andre Carvalho
2025-11-16 17:14 ` [PATCH net-next v4 5/5] selftests: netconsole: validate target resume Andre Carvalho
4 siblings, 0 replies; 10+ messages in thread
From: Andre Carvalho @ 2025-11-16 17:14 UTC (permalink / raw)
To: Breno Leitao, Andrew Lunn, David S. Miller, Eric Dumazet,
Jakub Kicinski, Paolo Abeni, Shuah Khan, Simon Horman
Cc: netdev, linux-kernel, linux-kselftest, Andre Carvalho
From: Breno Leitao <leitao@debian.org>
When the low level interface brings a netconsole target down, record this
using a new STATE_DEACTIVATED state. This allows netconsole to distinguish
between targets explicitly disabled by users and those deactivated due to
interface state changes.
It also enables automatic recovery and re-enabling of targets if the
underlying low-level interfaces come back online.
From a code perspective, anything that is not STATE_ENABLED is disabled.
Mark the device that is down due to NETDEV_UNREGISTER as
STATE_DEACTIVATED, this, should be the same as STATE_DISABLED from
a code perspective.
Signed-off-by: Breno Leitao <leitao@debian.org>
Signed-off-by: Andre Carvalho <asantostc@gmail.com>
---
drivers/net/netconsole.c | 11 ++++++++++-
1 file changed, 10 insertions(+), 1 deletion(-)
diff --git a/drivers/net/netconsole.c b/drivers/net/netconsole.c
index 2d15f7ab7235..5a374e6d178d 100644
--- a/drivers/net/netconsole.c
+++ b/drivers/net/netconsole.c
@@ -120,6 +120,7 @@ enum sysdata_feature {
enum target_state {
STATE_DISABLED,
STATE_ENABLED,
+ STATE_DEACTIVATED,
};
/**
@@ -575,6 +576,14 @@ static ssize_t enabled_store(struct config_item *item,
if (ret)
goto out_unlock;
+ /* When the user explicitly enables or disables a target that is
+ * currently deactivated, reset its state to disabled. The DEACTIVATED
+ * state only tracks interface-driven deactivation and should _not_
+ * persist when the user manually changes the target's enabled state.
+ */
+ if (nt->state == STATE_DEACTIVATED)
+ nt->state = STATE_DISABLED;
+
ret = -EINVAL;
current_enabled = nt->state == STATE_ENABLED;
if (enabled == current_enabled) {
@@ -1461,7 +1470,7 @@ static int netconsole_netdev_event(struct notifier_block *this,
case NETDEV_RELEASE:
case NETDEV_JOIN:
case NETDEV_UNREGISTER:
- nt->state = STATE_DISABLED;
+ nt->state = STATE_DEACTIVATED;
list_move(&nt->list, &target_cleanup_list);
stopped = true;
}
--
2.51.2
^ permalink raw reply related [flat|nested] 10+ messages in thread* [PATCH net-next v4 4/5] netconsole: resume previously deactivated target
2025-11-16 17:14 [PATCH net-next v4 0/5] netconsole: support automatic target recovery Andre Carvalho
` (2 preceding siblings ...)
2025-11-16 17:14 ` [PATCH net-next v4 3/5] netconsole: add STATE_DEACTIVATED to track targets disabled by low level Andre Carvalho
@ 2025-11-16 17:14 ` Andre Carvalho
2025-11-16 21:09 ` Andre Carvalho
2025-11-17 10:29 ` Breno Leitao
2025-11-16 17:14 ` [PATCH net-next v4 5/5] selftests: netconsole: validate target resume Andre Carvalho
4 siblings, 2 replies; 10+ messages in thread
From: Andre Carvalho @ 2025-11-16 17:14 UTC (permalink / raw)
To: Breno Leitao, Andrew Lunn, David S. Miller, Eric Dumazet,
Jakub Kicinski, Paolo Abeni, Shuah Khan, Simon Horman
Cc: netdev, linux-kernel, linux-kselftest, Andre Carvalho
Attempt to resume a previously deactivated target when the associated
interface comes back (NETDEV_UP event is received) by calling
__netpoll_setup on the device.
Depending on how the target was setup (by mac or interface name), the
corresponding field is compared with the device being brought up.
Targets that are candidates for resuming are removed from the target list
and added to a temp list, as __netpoll_setup is IRQ unsafe.
__netpoll_setup assumes RTNL is held (which is guaranteed to be the
case when handling the event). In case of success, hold a reference to
the device which will be removed upon target (or netconsole) removal by
netpoll_cleanup.
Target transitions to STATE_DISABLED in case of failures resuming it to
avoid retrying the same target indefinitely.
Signed-off-by: Andre Carvalho <asantostc@gmail.com>
---
drivers/net/netconsole.c | 81 ++++++++++++++++++++++++++++++++++++++++++++----
1 file changed, 75 insertions(+), 6 deletions(-)
diff --git a/drivers/net/netconsole.c b/drivers/net/netconsole.c
index 5a374e6d178d..2a5c470317b5 100644
--- a/drivers/net/netconsole.c
+++ b/drivers/net/netconsole.c
@@ -135,10 +135,14 @@ enum target_state {
* @stats: Packet send stats for the target. Used for debugging.
* @state: State of the target.
* Visible from userspace (read-write).
- * We maintain a strict 1:1 correspondence between this and
- * whether the corresponding netpoll is active or inactive.
+ * From a userspace perspective, the target is either enabled or
+ * disabled. Internally, although both STATE_DISABLED and
+ * STATE_DEACTIVATED correspond to inactive targets, the latter is
+ * due to automatic interface state changes and will try
+ * recover automatically, if the interface comes back
+ * online.
* Also, other parameters of a target may be modified at
- * runtime only when it is disabled (state == STATE_DISABLED).
+ * runtime only when it is disabled (state != STATE_ENABLED).
* @extended: Denotes whether console is extended or not.
* @release: Denotes whether kernel release version should be prepended
* to the message. Depends on extended console.
@@ -1445,17 +1449,75 @@ static int prepare_extradata(struct netconsole_target *nt)
}
#endif /* CONFIG_NETCONSOLE_DYNAMIC */
+/* Attempts to resume logging to a deactivated target. */
+static void maybe_resume_target(struct netconsole_target *nt,
+ struct net_device *ndev)
+{
+ int ret;
+
+ ret = __netpoll_setup(&nt->np, ndev);
+ if (ret) {
+ /* netpoll fails setup once, do not try again. */
+ nt->state = STATE_DISABLED;
+ return;
+ }
+
+ netdev_hold(ndev, &nt->np.dev_tracker, GFP_KERNEL);
+ nt->state = STATE_ENABLED;
+ pr_info("network logging resumed on interface %s\n", nt->np.dev_name);
+}
+
+/* Check if the target was bound by mac address. */
+static bool bound_by_mac(struct netconsole_target *nt)
+{
+ return is_valid_ether_addr(nt->np.dev_mac);
+}
+
+/* Checks if a deactivated target matches a device. */
+static bool deactivated_target_match(struct netconsole_target *nt,
+ struct net_device *ndev)
+{
+ if (nt->state != STATE_DEACTIVATED)
+ return false;
+
+ if (bound_by_mac(nt))
+ return !memcmp(nt->np.dev_mac, ndev->dev_addr, ETH_ALEN);
+ return !strncmp(nt->np.dev_name, ndev->name, IFNAMSIZ);
+}
+
+/* Process targets in resume_list and returns then to target_list */
+static void process_resumable_targets(struct list_head *resume_list,
+ struct net_device *ndev)
+{
+ struct netconsole_target *nt, *tmp;
+ unsigned long flags;
+
+ list_for_each_entry_safe(nt, tmp, resume_list, list) {
+ maybe_resume_target(nt, ndev);
+
+ /* At this point the target is either enabled or disabled and
+ * was cleaned up before getting deactivated. Either way, add it
+ * back to target list.
+ */
+ spin_lock_irqsave(&target_list_lock, flags);
+ list_move(&nt->list, &target_list);
+ spin_unlock_irqrestore(&target_list_lock, flags);
+ }
+}
+
/* Handle network interface device notifications */
static int netconsole_netdev_event(struct notifier_block *this,
unsigned long event, void *ptr)
{
- unsigned long flags;
- struct netconsole_target *nt, *tmp;
struct net_device *dev = netdev_notifier_info_to_dev(ptr);
+ struct netconsole_target *nt, *tmp;
+ LIST_HEAD(resume_list);
bool stopped = false;
+ unsigned long flags;
if (!(event == NETDEV_CHANGENAME || event == NETDEV_UNREGISTER ||
- event == NETDEV_RELEASE || event == NETDEV_JOIN))
+ event == NETDEV_RELEASE || event == NETDEV_JOIN ||
+ event == NETDEV_UP))
goto done;
mutex_lock(&target_cleanup_list_lock);
@@ -1475,6 +1537,11 @@ static int netconsole_netdev_event(struct notifier_block *this,
stopped = true;
}
}
+ if (event == NETDEV_UP && deactivated_target_match(nt, dev))
+ /* maybe_resume_target is IRQ unsafe, remove target from
+ * target_list in order to resume it with IRQ enabled.
+ */
+ list_move(&nt->list, &resume_list);
netconsole_target_put(nt);
}
spin_unlock_irqrestore(&target_list_lock, flags);
@@ -1498,6 +1565,8 @@ static int netconsole_netdev_event(struct notifier_block *this,
dev->name, msg);
}
+ process_resumable_targets(&resume_list, dev);
+
/* Process target_cleanup_list entries. By the end, target_cleanup_list
* should be empty
*/
--
2.51.2
^ permalink raw reply related [flat|nested] 10+ messages in thread* Re: [PATCH net-next v4 4/5] netconsole: resume previously deactivated target
2025-11-16 17:14 ` [PATCH net-next v4 4/5] netconsole: resume previously deactivated target Andre Carvalho
@ 2025-11-16 21:09 ` Andre Carvalho
2025-11-17 10:29 ` Breno Leitao
1 sibling, 0 replies; 10+ messages in thread
From: Andre Carvalho @ 2025-11-16 21:09 UTC (permalink / raw)
To: Breno Leitao, Andrew Lunn, David S. Miller, Eric Dumazet,
Jakub Kicinski, Paolo Abeni, Shuah Khan, Simon Horman
Cc: netdev, linux-kernel, linux-kselftest
On Sun, Nov 16, 2025 at 05:14:04PM +0000, Andre Carvalho wrote:
> /* Handle network interface device notifications */
> static int netconsole_netdev_event(struct notifier_block *this,
> unsigned long event, void *ptr)
> {
> - unsigned long flags;
> - struct netconsole_target *nt, *tmp;
> struct net_device *dev = netdev_notifier_info_to_dev(ptr);
> + struct netconsole_target *nt, *tmp;
> + LIST_HEAD(resume_list);
> bool stopped = false;
> + unsigned long flags;
>
> if (!(event == NETDEV_CHANGENAME || event == NETDEV_UNREGISTER ||
> - event == NETDEV_RELEASE || event == NETDEV_JOIN))
> + event == NETDEV_RELEASE || event == NETDEV_JOIN ||
> + event == NETDEV_UP))
> goto done;
>
> mutex_lock(&target_cleanup_list_lock);
> @@ -1475,6 +1537,11 @@ static int netconsole_netdev_event(struct notifier_block *this,
> stopped = true;
> }
> }
> + if (event == NETDEV_UP && deactivated_target_match(nt, dev))
> + /* maybe_resume_target is IRQ unsafe, remove target from
> + * target_list in order to resume it with IRQ enabled.
> + */
> + list_move(&nt->list, &resume_list);
> netconsole_target_put(nt);
> }
I've noticed the test failure in CI (test #4 in netcons-over-bonding-sh)
and I'm able to reproduce it locally. I was only running 'drivers/net' and missed
'drivers/net/bonding' netconsole tests locally - will adjust my tests to always
include those. They are certainly related to this changes.
Looking at logs, it seems like we re-enable the target before the interface is enslaved:
[ 28.707460] netconsole: netconsole: local port 6665
[ 28.707472] netconsole: netconsole: local IPv4 address 192.0.2.1
[ 28.707479] netconsole: netconsole: interface name 'nsim950'
[ 28.707483] netconsole: netconsole: local ethernet address '00:00:00:00:00:00'
[ 28.707487] netconsole: netconsole: remote port 6666
[ 28.707490] netconsole: netconsole: remote IPv4 address 192.0.2.2
[ 28.707494] netconsole: netconsole: remote ethernet address 4a:00:f1:39:50:c4
[ 28.707502] netpoll: netconsole: device nsim950 not up yet, forcing it
[ 28.717516] netconsole: network logging started
[ 28.740938] netconsole: network logging stopped on interface nsim950 as it is joining a master device
[ 28.741034] netconsole: network logging resumed on interface nsim950
[ 28.741076] bond_tx_25: (slave nsim950): Enslaving as an active interface with an up link
[ 28.752003] printk: legacy console [netcon_ext0] disabled
I'll debug some more to understand this a bit better and think how to address it. Perhaps the
target needs to be DISABLED instead of DEACTIVATED when handling NETDEV_JOIN.
--
Andre Carvalho
^ permalink raw reply [flat|nested] 10+ messages in thread* Re: [PATCH net-next v4 4/5] netconsole: resume previously deactivated target
2025-11-16 17:14 ` [PATCH net-next v4 4/5] netconsole: resume previously deactivated target Andre Carvalho
2025-11-16 21:09 ` Andre Carvalho
@ 2025-11-17 10:29 ` Breno Leitao
1 sibling, 0 replies; 10+ messages in thread
From: Breno Leitao @ 2025-11-17 10:29 UTC (permalink / raw)
To: Andre Carvalho
Cc: Andrew Lunn, David S. Miller, Eric Dumazet, Jakub Kicinski,
Paolo Abeni, Shuah Khan, Simon Horman, netdev, linux-kernel,
linux-kselftest
Hello Andre,
Given you are going to respin this oen due to the NIPA errors, let me
get some nits I found.
On Sun, Nov 16, 2025 at 05:14:04PM +0000, Andre Carvalho wrote:
> +/* Attempts to resume logging to a deactivated target. */
> +static void maybe_resume_target(struct netconsole_target *nt,
> + struct net_device *ndev)
nit: s/maybe_resume_target/resume_target/
> +{
> + int ret;
> +
> + ret = __netpoll_setup(&nt->np, ndev);
> + if (ret) {
> + /* netpoll fails setup once, do not try again. */
> + nt->state = STATE_DISABLED;
> + return;
> + }
> +
> + netdev_hold(ndev, &nt->np.dev_tracker, GFP_KERNEL);
In netpoll_setup(), it calls netdev_hold() first, and then
call __netpoll_setup(). Shouldn't net device be held before trying to to
setup netpoll()?
> +static bool deactivated_target_match(struct netconsole_target *nt,
> + struct net_device *ndev)
> +{
> + if (nt->state != STATE_DEACTIVATED)
> + return false;
> +
> + if (bound_by_mac(nt))
> + return !memcmp(nt->np.dev_mac, ndev->dev_addr, ETH_ALEN);
> + return !strncmp(nt->np.dev_name, ndev->name, IFNAMSIZ);
> +}
> +
> +/* Process targets in resume_list and returns then to target_list */
s/then/them
> +static void process_resumable_targets(struct list_head *resume_list,
> + struct net_device *ndev)
nit: s/process_resumable_targets/netconsole_process_resumable_tagets/
The name is not the best, but it matches a similar function
(netconsole_process_cleanups_core())
> @@ -1475,6 +1537,11 @@ static int netconsole_netdev_event(struct notifier_block *this,
> stopped = true;
> }
> }
> + if (event == NETDEV_UP && deactivated_target_match(nt, dev))
> + /* maybe_resume_target is IRQ unsafe, remove target from
> + * target_list in order to resume it with IRQ enabled.
> + */
> + list_move(&nt->list, &resume_list);
> netconsole_target_put(nt);
> }
> spin_unlock_irqrestore(&target_list_lock, flags);
> @@ -1498,6 +1565,8 @@ static int netconsole_netdev_event(struct notifier_block *this,
> dev->name, msg);
> }
>
> + process_resumable_targets(&resume_list, dev);
Nice, this new approach looks cleaner now.
--breno
^ permalink raw reply [flat|nested] 10+ messages in thread
* [PATCH net-next v4 5/5] selftests: netconsole: validate target resume
2025-11-16 17:14 [PATCH net-next v4 0/5] netconsole: support automatic target recovery Andre Carvalho
` (3 preceding siblings ...)
2025-11-16 17:14 ` [PATCH net-next v4 4/5] netconsole: resume previously deactivated target Andre Carvalho
@ 2025-11-16 17:14 ` Andre Carvalho
2025-11-16 18:59 ` Andre Carvalho
2025-11-17 10:35 ` Breno Leitao
4 siblings, 2 replies; 10+ messages in thread
From: Andre Carvalho @ 2025-11-16 17:14 UTC (permalink / raw)
To: Breno Leitao, Andrew Lunn, David S. Miller, Eric Dumazet,
Jakub Kicinski, Paolo Abeni, Shuah Khan, Simon Horman
Cc: netdev, linux-kernel, linux-kselftest, Andre Carvalho
Introduce a new netconsole selftest to validate that netconsole is able
to resume a deactivated target when the low level interface comes back.
The test setups the network using netdevsim, creates a netconsole target
and then remove/add netdevsim in order to bring the same interfaces
back. Afterwards, the test validates that the target works as expected.
Targets are created via cmdline parameters to the module to ensure that
we are able to resume targets that were bound by mac and interface name.
Signed-off-by: Andre Carvalho <asantostc@gmail.com>
---
tools/testing/selftests/drivers/net/Makefile | 1 +
.../selftests/drivers/net/lib/sh/lib_netcons.sh | 35 ++++++--
.../selftests/drivers/net/netcons_resume.sh | 97 ++++++++++++++++++++++
3 files changed, 128 insertions(+), 5 deletions(-)
diff --git a/tools/testing/selftests/drivers/net/Makefile b/tools/testing/selftests/drivers/net/Makefile
index 33f4816216ec..7dc9e5b23d5b 100644
--- a/tools/testing/selftests/drivers/net/Makefile
+++ b/tools/testing/selftests/drivers/net/Makefile
@@ -17,6 +17,7 @@ TEST_PROGS := \
netcons_cmdline.sh \
netcons_fragmented_msg.sh \
netcons_overflow.sh \
+ netcons_resume.sh \
netcons_sysdata.sh \
netcons_torture.sh \
netpoll_basic.py \
diff --git a/tools/testing/selftests/drivers/net/lib/sh/lib_netcons.sh b/tools/testing/selftests/drivers/net/lib/sh/lib_netcons.sh
index 87f89fd92f8c..6157db660067 100644
--- a/tools/testing/selftests/drivers/net/lib/sh/lib_netcons.sh
+++ b/tools/testing/selftests/drivers/net/lib/sh/lib_netcons.sh
@@ -203,19 +203,21 @@ function do_cleanup() {
function cleanup_netcons() {
# delete netconsole dynamic reconfiguration
# do not fail if the target is already disabled
- if [[ ! -d "${NETCONS_PATH}" ]]
+ local TARGET_PATH=${1:-${NETCONS_PATH}}
+
+ if [[ ! -d "${TARGET_PATH}" ]]
then
# in some cases this is called before netcons path is created
return
fi
- if [[ $(cat "${NETCONS_PATH}"/enabled) != 0 ]]
+ if [[ $(cat "${TARGET_PATH}"/enabled) != 0 ]]
then
- echo 0 > "${NETCONS_PATH}"/enabled || true
+ echo 0 > "${TARGET_PATH}"/enabled || true
fi
# Remove all the keys that got created during the selftest
- find "${NETCONS_PATH}/userdata/" -mindepth 1 -type d -delete
+ find "${TARGET_PATH}/userdata/" -mindepth 1 -type d -delete
# Remove the configfs entry
- rmdir "${NETCONS_PATH}"
+ rmdir "${TARGET_PATH}"
}
function cleanup() {
@@ -377,6 +379,29 @@ function check_netconsole_module() {
fi
}
+function wait_target_state() {
+ local TARGET=${1}
+ local STATE=${2}
+ local TARGET_PATH="${NETCONS_CONFIGFS}"/"${TARGET}"
+ local ENABLED=0
+
+ if [ "${STATE}" == "enabled" ]
+ then
+ local ENABLED=1
+ fi
+
+ if [ ! -d "$TARGET_PATH" ]; then
+ echo "FAIL: Target does not exist." >&2
+ exit "${ksft_fail}"
+ fi
+
+ local CHECK_CMD="grep \"$ENABLED\" \"$TARGET_PATH/enabled\""
+ slowwait 2 sh -c "test -n \"\$($CHECK_CMD)\"" || {
+ echo "FAIL: ${TARGET} is not ${STATE}." >&2
+ exit "${ksft_fail}"
+ }
+}
+
# A wrapper to translate protocol version to udp version
function wait_for_port() {
local NAMESPACE=${1}
diff --git a/tools/testing/selftests/drivers/net/netcons_resume.sh b/tools/testing/selftests/drivers/net/netcons_resume.sh
new file mode 100755
index 000000000000..8f7f07779c41
--- /dev/null
+++ b/tools/testing/selftests/drivers/net/netcons_resume.sh
@@ -0,0 +1,97 @@
+#!/usr/bin/env bash
+# SPDX-License-Identifier: GPL-2.0
+
+# This test validates that netconsole is able to resume a target that was
+# deactivated when its interface was removed when the interface is brought
+# back up.
+#
+# The test configures a netconsole target and then removes netdevsim module to
+# cause the interface to disappear. Targets are configured via cmdline to ensure
+# targets bound by interface name and mac address can be resumed.
+# The test verifies that the target moved to disabled state before adding
+# netdevsim and the interface back.
+#
+# Finally, the test verifies that the target is re-enabled automatically and
+# the message is received on the destination interface.
+#
+# Author: Andre Carvalho <asantostc@gmail.com>
+
+set -euo pipefail
+
+SCRIPTDIR=$(dirname "$(readlink -e "${BASH_SOURCE[0]}")")
+
+source "${SCRIPTDIR}"/lib/sh/lib_netcons.sh
+
+modprobe netdevsim 2> /dev/null || true
+rmmod netconsole 2> /dev/null || true
+
+check_netconsole_module
+
+function cleanup() {
+ cleanup_netcons "${NETCONS_CONFIGFS}/cmdline0"
+ do_cleanup
+ rmmod netconsole
+}
+
+trap cleanup EXIT
+
+# Run the test twice, with different cmdline parameters
+for BINDMODE in "ifname" "mac"
+do
+ echo "Running with bind mode: ${BINDMODE}" >&2
+ # Set current loglevel to KERN_INFO(6), and default to KERN_NOTICE(5)
+ echo "6 5" > /proc/sys/kernel/printk
+
+ # Create one namespace and two interfaces
+ set_network
+
+ # Create the command line for netconsole, with the configuration from
+ # the function above
+ CMDLINE=$(create_cmdline_str "${BINDMODE}")
+
+ # The content of kmsg will be save to the following file
+ OUTPUT_FILE="/tmp/${TARGET}-${BINDMODE}"
+
+ # Load the module, with the cmdline set
+ modprobe netconsole "${CMDLINE}"
+ # Expose cmdline target in configfs
+ mkdir "${NETCONS_CONFIGFS}/cmdline0"
+
+ # Target should be enabled
+ wait_target_state "cmdline0" "enabled"
+
+ # Remove low level module
+ rmmod netdevsim
+ # Target should be disabled
+ wait_target_state "cmdline0" "disabled"
+
+ # Add back low level module
+ modprobe netdevsim
+ # Recreate namespace and two interfaces
+ set_network
+ # Target should be enabled again
+ wait_target_state "cmdline0" "enabled"
+
+ # Listen for netconsole port inside the namespace and destination
+ # interface
+ listen_port_and_save_to "${OUTPUT_FILE}" &
+ # Wait for socat to start and listen to the port.
+ wait_local_port_listen "${NAMESPACE}" "${PORT}" udp
+ # Send the message
+ echo "${MSG}: ${TARGET}" > /dev/kmsg
+ # Wait until socat saves the file to disk
+ busywait "${BUSYWAIT_TIMEOUT}" test -s "${OUTPUT_FILE}"
+ # Make sure the message was received in the dst part
+ # and exit
+ validate_msg "${OUTPUT_FILE}"
+
+ # kill socat in case it is still running
+ pkill_socat
+ # Cleanup & unload the module
+ cleanup
+ trap - EXIT
+
+ echo "${BINDMODE} : Test passed" >&2
+done
+
+exit "${ksft_pass}"
--
2.51.2
^ permalink raw reply related [flat|nested] 10+ messages in thread* Re: [PATCH net-next v4 5/5] selftests: netconsole: validate target resume
2025-11-16 17:14 ` [PATCH net-next v4 5/5] selftests: netconsole: validate target resume Andre Carvalho
@ 2025-11-16 18:59 ` Andre Carvalho
2025-11-17 10:35 ` Breno Leitao
1 sibling, 0 replies; 10+ messages in thread
From: Andre Carvalho @ 2025-11-16 18:59 UTC (permalink / raw)
To: Breno Leitao, Andrew Lunn, David S. Miller, Eric Dumazet,
Jakub Kicinski, Paolo Abeni, Shuah Khan, Simon Horman
Cc: netdev, linux-kernel, linux-kselftest
On Sun, Nov 16, 2025 at 05:14:05PM +0000, Andre Carvalho wrote:
> + pkill_socat
> + # Cleanup & unload the module
> + cleanup
> + trap - EXIT
I noticed a small mistake here. This trap line should be outside of the loop,
right before exit. I'll send v5 fixing this after the 24h cooldown period.
> +
> + echo "${BINDMODE} : Test passed" >&2
> +done
> +
> +exit "${ksft_pass}"
>
> --
> 2.51.2
>
--
Andre Carvalho
^ permalink raw reply [flat|nested] 10+ messages in thread* Re: [PATCH net-next v4 5/5] selftests: netconsole: validate target resume
2025-11-16 17:14 ` [PATCH net-next v4 5/5] selftests: netconsole: validate target resume Andre Carvalho
2025-11-16 18:59 ` Andre Carvalho
@ 2025-11-17 10:35 ` Breno Leitao
1 sibling, 0 replies; 10+ messages in thread
From: Breno Leitao @ 2025-11-17 10:35 UTC (permalink / raw)
To: Andre Carvalho
Cc: Andrew Lunn, David S. Miller, Eric Dumazet, Jakub Kicinski,
Paolo Abeni, Shuah Khan, Simon Horman, netdev, linux-kernel,
linux-kselftest
On Sun, Nov 16, 2025 at 05:14:05PM +0000, Andre Carvalho wrote:
> Introduce a new netconsole selftest to validate that netconsole is able
> to resume a deactivated target when the low level interface comes back.
>
> The test setups the network using netdevsim, creates a netconsole target
> and then remove/add netdevsim in order to bring the same interfaces
> back. Afterwards, the test validates that the target works as expected.
>
> Targets are created via cmdline parameters to the module to ensure that
> we are able to resume targets that were bound by mac and interface name.
>
> Signed-off-by: Andre Carvalho <asantostc@gmail.com>
> ---
> tools/testing/selftests/drivers/net/Makefile | 1 +
> .../selftests/drivers/net/lib/sh/lib_netcons.sh | 35 ++++++--
> .../selftests/drivers/net/netcons_resume.sh | 97 ++++++++++++++++++++++
> 3 files changed, 128 insertions(+), 5 deletions(-)
>
> diff --git a/tools/testing/selftests/drivers/net/Makefile b/tools/testing/selftests/drivers/net/Makefile
> index 33f4816216ec..7dc9e5b23d5b 100644
> --- a/tools/testing/selftests/drivers/net/Makefile
> +++ b/tools/testing/selftests/drivers/net/Makefile
> @@ -17,6 +17,7 @@ TEST_PROGS := \
> netcons_cmdline.sh \
> netcons_fragmented_msg.sh \
> netcons_overflow.sh \
> + netcons_resume.sh \
> netcons_sysdata.sh \
> netcons_torture.sh \
> netpoll_basic.py \
> diff --git a/tools/testing/selftests/drivers/net/lib/sh/lib_netcons.sh b/tools/testing/selftests/drivers/net/lib/sh/lib_netcons.sh
> index 87f89fd92f8c..6157db660067 100644
> --- a/tools/testing/selftests/drivers/net/lib/sh/lib_netcons.sh
> +++ b/tools/testing/selftests/drivers/net/lib/sh/lib_netcons.sh
> @@ -203,19 +203,21 @@ function do_cleanup() {
> function cleanup_netcons() {
> # delete netconsole dynamic reconfiguration
> # do not fail if the target is already disabled
> - if [[ ! -d "${NETCONS_PATH}" ]]
> + local TARGET_PATH=${1:-${NETCONS_PATH}}
> +
> + if [[ ! -d "${TARGET_PATH}" ]]
> then
> # in some cases this is called before netcons path is created
> return
> fi
> - if [[ $(cat "${NETCONS_PATH}"/enabled) != 0 ]]
> + if [[ $(cat "${TARGET_PATH}"/enabled) != 0 ]]
> then
> - echo 0 > "${NETCONS_PATH}"/enabled || true
> + echo 0 > "${TARGET_PATH}"/enabled || true
> fi
> # Remove all the keys that got created during the selftest
> - find "${NETCONS_PATH}/userdata/" -mindepth 1 -type d -delete
> + find "${TARGET_PATH}/userdata/" -mindepth 1 -type d -delete
> # Remove the configfs entry
> - rmdir "${NETCONS_PATH}"
> + rmdir "${TARGET_PATH}"
> }
>
> function cleanup() {
> @@ -377,6 +379,29 @@ function check_netconsole_module() {
> fi
> }
>
> +function wait_target_state() {
> + local TARGET=${1}
> + local STATE=${2}
> + local TARGET_PATH="${NETCONS_CONFIGFS}"/"${TARGET}"
> + local ENABLED=0
> +
> + if [ "${STATE}" == "enabled" ]
> + then
> + local ENABLED=1
ENABLED is already marked as local above. "local" here is unnecessary.
Other than that, and with the "trap" fix, it might be in good shape.
Thanks for this selftest.
--breno
--
pw-bot: cr
^ permalink raw reply [flat|nested] 10+ messages in thread